var RE = {};
window.onload = function () {
    TapTapAPI('loadFinish', 1)
};
RE.editor = document.getElementById('editor');
RE.editor.addEventListener("input",
    function () {
        TapTapAPI('getHtmlForDraft', RE.editor.innerHTML)
        RE.callback();
        RE.updatePlaceholder();
        RE.backuprange();
        RE.calculateEditorHeightWithCaretPosition()
        // TapTapAPI('YY',RE.getRelativeCaretYPosition())
        // RE.callback("input");
    });
RE.calculateEditorHeightWithCaretPosition = function () {
    var padding = 50;
    var c = RE.getRelativeCaretYPosition(); //\u5149\u6807\u4f4d\u7f6e
    var offsetY = window.document.body.scrollTop; //euqal window.pageYOffset;
    var height = document.documentElement.clientHeight;
    var newPos = window.pageYOffset;
    if (c < offsetY) {
        newPos = c;
    }
    else if (c > (offsetY + height - padding)) {
        newPos = c - height + padding - 18;
    }
    window.scrollTo(0, newPos + 15);
}
TapTapAPI = function (a, b, c, d) {
}
RE.editor.addEventListener("focus",
    function () {
        RE.backuprange();
        TapTapAPI('click', 1)
    });

RE.editor.addEventListener("click", function () {
    RE.backuprange();
    TapTapAPI('click', 1)
});

RE.editor.addEventListener("blur", function () {
    RE.callback("blur");
});
RE.customAction = function (action) {
    RE.callback("action/" + action);
};
RE.updateHeight = function () {
    RE.callback("updateHeight");
}
RE.callbackQueue = [];
RE.runCallbackQueue = function () {
    if (RE.callbackQueue.length === 0) {
        return;
    }
    setTimeout(function () {
        window.location.href = "re-callback://";
    }, 0);
};
RE.getCommandQueue = function () {
    var commands = JSON.stringify(RE.callbackQueue);
    RE.callbackQueue = [];
    return commands;
};
RE.callback = function (method) {
    console.log(RE.editor.innerHTML);

    window.postMessage('getContent:::' + RE.editor.innerHTML);

//    RE.callbackQueue.push(method);
//    RE.runCallbackQueue();
};
RE.setHtml = function (contents) {
    RE.editor.innerHTML = contents;
};

RE.getHtml = function (type) {
    if (type == 'send') {
        TapTapAPI('getHtmlForSend',
            RE.editor.innerHTML)
    } else if (type == 'draft') {
        TapTapAPI('getHtmlForDraft',

            RE.editor.innerHTML)
    }
};
RE.getText = function () {
    return
    RE.editor.innerText;
};
RE.setPlaceholderText = function (text) {
    RE.editor.setAttribute("placeholder", text);
};
RE.updatePlaceholder = function () {
    if (
        RE.editor.textContent.length > 0) {
        RE.editor.classList.remove("placeholder");
    } else {
        RE.editor.classList.add("placeholder");
    }
};
RE.removeFormat = function () {
    document.execCommand('removeFormat', false, null);
};
RE.setFontSize = function (size) {
    RE.editor.style.fontSize = size;
};
RE.setBackgroundColor = function (color) {
    RE.editor.style.backgroundColor = color;
};
RE.setHeight = function (size) {
    RE.editor.style.height = size;
};
RE.undo = function () {
    document.execCommand('undo', false, null);
};
RE.redo = function () {
    document.execCommand('redo', false, null);
};
RE.wrapTextNodesWithBold = function () {
    var sel = window.getSelection();
    if (!sel.isCollapsed) {
        var contents = RE.getSelectedNodes();
        for (var i = 0; i < contents.length; i++) {
            if (contents[i].nodeType === Node.TEXT_NODE) {
                var newNode = document.createElement('b');
                RE.createWrapper(contents[i], newNode);
            }
        }
    } else {
        var bold = document.createElement('b')
        var range = sel.getRangeAt(0);
        range.insertNode(bold);
        range.selectNodeContents(bold);
        range.collapse(false);
        sel.removeAllRanges();
        sel.addRange(range);
    }
};

RE.cancelBoldWrapper = function () {
    var sel = window.getSelection()
    if (!sel.isCollapsed) {
        var contents = RE.getSelectedNodes();
        for (var i = 0; i < contents.length; i++) {
            TapTapAPI('OOOOO', contents[i].nodeName.toLowerCase())
            if (contents[i].nodeName.toLowerCase() == 'strong' || contents[i].nodeName.toLowerCase() == 'b') {
                var firstChild = contents[i].childNodes[0];
                contents[i].replaceWith(firstChild)
            }
        }
    }
    else {
        var span = document.createElement('span')
        var range = sel.getRangeAt(0);
        range.insertNode(span);
    }
};
function nextNode(node) {
    if (node.hasChildNodes()) {
        return node.firstChild;
    } else {
        while (node && !node.nextSibling) {
            node = node.parentNode;
        }
        if (!node) {
            return null;
        }
        return node.nextSibling;
    }
};
// function getAllParentNodeName(node){
//     var nodeNames = [];
//     while (node) {
//         nodeNames.push(node.nodeName);


//         node = node.parentNode;
//     }
// }
// function getRangeSelectedNodes(range) {
//     var node = range.startContainer;
//     var endNode = range.endContainer;
//
//range.startOffset
//
// Special case for a range that is contained within a single node
//     if (node == endNode) {
//         if(node.nodeType == 3)
//text node
//            if(!getAllParentNodeName(node).includes('b') )
// \u4e0d\u662f\u52a0\u7c97\u72b6\u6001
//            {
//                var bNode = document.createElement('b')
//                RE.createWrapper(node,bNode)
//            }
//                 return [node];
//     }
//
// Iterate nodes until we hit the end container
//     var rangeNodes = [];
//     while (node && node != endNode) {
//         rangeNodes.push( node = nextNode(node) );
//     }
//
// Add partially selected nodes at the start of the range
//     node = range.startContainer;
//     while (node && node != range.commonAncestorContainer) {
//         rangeNodes.unshift(node);
//         node = node.parentNode;
//     }
//     return rangeNodes;
// };
// RE.getSelectedNodes = function() {
//     if (window.getSelection) {
//         var sel = window.getSelection();
//         if (!sel.isCollapsed) {
//             return getRangeSelectedNodes(sel.getRangeAt(0));
//         }
//     }
//     return [];
// };
// RE.createWrapper = function(elms, node) {
//     var child = node.cloneNode(true);
//     var el    = elms;
//     var parent  = el.parentNode;
//     var sibling = el.nextSibling;
//     child.appendChild(el);
//     if (sibling) {
//         parent.insertBefore(child, sibling);
//     } else {
//         parent.appendChild(child);
//     }
// };RE.setBold = function() {    var sel = window.getSelection();    document.execCommand('bold', false, null);
// if (sel.isCollapsed) {
//     document.execCommand('bold', false, null);
// }else{
//     TapTapAPI('showPrompt',true)
// }    if(!document.queryCommandState('bold')){        TapTapAPI('boldState',false)    }else{        TapTapAPI('boldState',true)    }
// var sel = window.getSelection();
// if(sel.collapse){
//     document.execCommand('bold', false, null);
// }
//document.execCommand('bold', false, null);
// if(!document.queryCommandState('bold')){
//     RE.wrapTextNodesWithBold();
// }else{
//     RE.cancelBoldWrapper();
// }};
RE.insertHTML = function (html) {
    RE.restorerange();
    document.execCommand('insertHTML', false, html);
};
RE.setItalic = function () {
    document.execCommand('italic', false, null);
};
RE.setSubscript = function () {
    document.execCommand('subscript', false, null);
};
RE.setSuperscript = function () {
    document.execCommand('superscript', false, null);
};
RE.setStrikeThrough = function () {
    document.execCommand('strikeThrough', false, null);
};
RE.setUnderline = function () {
    document.execCommand('underline', false, null);
};
RE.setTextColor = function (color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('foreColor', false, color);
    document.execCommand("styleWithCSS", null, false);
};
RE.setTextBackgroundColor = function (color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('hiliteColor', false, color);
    document.execCommand("styleWithCSS", null, false);
};
RE.setHeading = function (heading) {
    document.execCommand('formatBlock', false, ' < h ' + heading + ' > ');
};
RE.setIndent = function () {
    document.execCommand('indent', false, null);
};
RE.setOutdent =
    function () {
        document.execCommand('outdent', false, null);
    };
RE.setOrderedList =
    function () {
        document.execCommand('insertOrderedList', false, null);
    };
RE.setUnorderedList =
    function () {
        document.execCommand('insertUnorderedList', false, null);
    };
RE.setJustifyLeft =
    function () {
        document.execCommand('justifyLeft', false, null);
    };
RE.setJustifyCenter =
    function () {
        document.execCommand('justifyCenter', false, null);
    };
RE.setJustifyRight =
    function () {
        document.execCommand('justifyRight', false, null);
    };
RE.insertImage = function (url, alt, width, height) {
    var img = document.createElement('img');
    img.src = url;
    img.style.display = "block"
    img.style.height = height
    img.style.width = width
    if (!RE.currentSelection) {

        document.getElementById('editor').appendChild(img);
    } else {
        RE.restorerange();
        var sel = window.getSelection();
        var range = sel.getRangeAt(0);
        range.insertNode(img);
    }
};
RE.setBlockquote = function () {
    document.execCommand('formatBlock', false, '<blockquote>');
};
RE.deleteForward = function () {
    document.execCommand('delete', false, null);
}
RE.getTextWidth = function (text, font) {
    var canvas = getTextWidth.canvas || (getTextWidth.canvas = document.createElement("canvas"));
    var context = canvas.getContext("2d");
    context.font = font;
    var metrics = context.measureText(text);
    return metrics.width;
}
RE.insertLink = function (id, url, title) {
    var canvas = document.createElement("canvas");
    var scale = 2;
    var ctx = canvas.getContext('2d');
    ctx.imageSmoothingEnabled = false;
    ctx.font = "bold 15px Courie";
    var metrics = ctx.measureText('  ' + title + '  ');
    var width = metrics.width
    if (width > document.getElementById('editor').clientWidth - 24) {
        width = document.getElementById('editor').clientWidth - 24
    }
    canvas.width = width * scale;
    canvas.height = 20 * scale;
    canvas.style.width = width + 'px';
    canvas.style.height = 20 + 'px';
    ctx.strokeStyle = "rgba(255, 0, 0,0)";
    ctx.fillStyle = '#dcdcdc';
    roundRect(ctx, 0, 0, width * scale, 20 * scale, 5, true);
    ctx.fillStyle = '#000';
    ctx.font = "bold 30px Courie";
    ctx.textBaseline = "top";
    ctx.fillText('  ' + title + '  ', 0, 3);
    var img = new Image();
    img.setAttribute('data-type', 'bbcode-app');
    img.setAttribute('data-id', id)
    img.setAttribute('data-name', title)
    img.src = canvas.toDataURL();
    img.width = width
    img.style.display = 'block';
    if (!RE.currentSelection) {
        document.getElementById('editor').appendChild(img);
    } else {
        RE.restorerange();
        var sel = window.getSelection();
        var range = sel.getRangeAt(0);
        range.insertNode(img);
    }
}
RE.prepareInsert = function () {
    RE.backuprange();
};
function roundRect(ctx, x, y, width, height, radius, fill, stroke) {
    if (typeof stroke == 'undefined') {
        stroke = true;
    }
    if (typeof radius === 'undefined') {
        radius = 5;
    }
    if (typeof radius === 'number') {
        radius = {tl: radius, tr: radius, br: radius, bl: radius};
    }
    else {
        var defaultRadius = {tl: 0, tr: 0, br: 0, bl: 0};
        for (var side in defaultRadius) {
            radius[side] = radius[side] || defaultRadius[side];
        }
    }
    ctx.beginPath();
    ctx.moveTo(x + radius.tl, y);
    ctx.lineTo(x + width - radius.tr, y);
    ctx.quadraticCurveTo(x + width, y, x + width, y + radius.tr);
    ctx.lineTo(x + width, y + height - radius.br);
    ctx.quadraticCurveTo(x + width, y + height, x + width - radius.br, y + height);
    ctx.lineTo(x + radius.bl, y + height);
    ctx.quadraticCurveTo(x, y + height, x, y + height - radius.bl);
    ctx.lineTo(x, y + radius.tl);
    ctx.quadraticCurveTo(x, y, x + radius.tl, y);
    ctx.closePath();
    if (fill) {
        ctx.fill();
    }
    if (stroke) {
        ctx.stroke();
    }
}

RE.replaceAppLink = function (html, linkBundle) {
    var arr = []
    var canvas = RE.replaceAppLink.canvas || (RE.replaceAppLink.canvas = document.createElement("canvas"));
    for (var i = 0; i < linkBundle.length; i++) {
        var title = linkBundle[i].title;
        var id = linkBundle[i].id;
        var scale = 2;
        var ctx = canvas.getContext('2d');
        ctx.font = "bold 15px Courie";
        var metrics = ctx.measureText(' ' + title + ' ');
        var width = metrics.width
        if (width > document.getElementById('editor').clientWidth - 24) {
            width = document.getElementById('editor').clientWidth - 24
        }
        canvas.width = width * scale;
        canvas.height = 22 * scale;
        canvas.style.width = width + 'px';
        canvas.style.height = 22 + 'px';
        ctx.strokeStyle = "rgba(255, 0, 0,0)";
        ctx.fillStyle = '#dcdcdc';
        roundRect(ctx, 0, 0, width * scale, 22 * scale, 5, true);
        ctx.fillStyle = '#000';
        ctx.font = "bold 30px Courie";
        ctx.textBaseline = "top";
        ctx.fillText(' ' + title + ' ', 0, 3);
        var img = new Image();
        img.setAttribute('data-type', 'bbcode-app');
        img.setAttribute('data-id', id)
        img.setAttribute('data-name', title)
        img.src = canvas.toDataURL();
        img.width = width;
        img.style.display = 'block';
        var imgStr = img.outerHTML;
        arr.push(imgStr)
    }
    TapTapAPI('replaceAppLink', JSON.stringify(arr))
}
RE.backuprange = function () {
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
        var range = selection.getRangeAt(0);
        RE.currentSelection = {
            "startContainer": range.startContainer,
            "startOffset": range.startOffset,
            "endContainer": range.endContainer,
            "endOffset": range.endOffset
        };
    }
};
RE.addRangeToSelection = function (selection, range) {
    if (selection) {
        selection.removeAllRanges();
        selection.addRange(range);
    }
};//

RE.selectElementContents =
    function (el) {
        var range = document.createRange();
        range.selectNodeContents(el);
        var sel = window.getSelection();    // this.createSelectionFromRange sel, range
        RE.addRangeToSelection(sel, range);
    };
RE.restorerange = function () {
    var selection = window.getSelection();
    selection.removeAllRanges();
    var range = document.createRange();
    range.setStart(
        RE.currentSelection.startContainer,
        RE.currentSelection.startOffset
    );
    range.setEnd(
        RE.currentSelection.endContainer,
        RE.currentSelection.endOffset);
    selection.addRange(range);
};
RE.focus = function () {
    var range = document.createRange();
    range.selectNodeContents(RE.editor);
    range.collapse(false);
    var selection = window.getSelection();
    selection.removeAllRanges();
    selection.addRange(range);
    RE.editor.focus();
};
RE.blurFocus = function () {
    RE.editor.blur();
};
/**Recursively search element ancestors to find a element nodeName e.g. A**/
var _findNodeByNameInContainer = function (element, nodeName, rootElementId) {
    if (element.nodeName == nodeName) {
        return element;
    }
    else {
        if (element.id === rootElementId) {
            return null;
        }
        _findNodeByNameInContainer(element.parentElement, nodeName, rootElementId);
    }
};
var isAnchorNode = function (node) {
    return ("A" == node.nodeName);
};
RE.getAnchorTagsInNode = function (node) {
    var links = [];
    while (node.nextSibling !== null && node.nextSibling !== undefined) {
        node = node.nextSibling;
        if (isAnchorNode(node)) {
            inks.push(node.getAttribute('href'));
        }
    }
    return links;
};
RE.countAnchorTagsInNode = function (node) {
    return RE.getAnchorTagsInNode(node).length;
};
/** * If the current selection's parent is an anchor tag, get the href. * @returns {string} */
RE.getSelectedHref = function () {
    var href, sel;
    href = '';
    sel = window.getSelection();
    if (!RE.rangeOrCaretSelectionExists()) {
        return null;
    }
    var tags = RE.getAnchorTagsInNode(sel.anchorNode);    //if more than one link is there, return null
    if (tags.length > 1) {
        return null;
    }
    else if (tags.length == 1) {
        href = tags[0];
    } else {
        var node = _findNodeByNameInContainer(sel.anchorNode.parentElement, 'A', 'editor');
        href = node.href;
    }
    return href ? href : null;
};
/* Make sure all text nodes are wrapped in divs! */
RE.wrapTextNodes = function () {
    var contents = RE.editor.childNodes;
    for (var i = 0; i < contents.length; i++) {
        if (contents[i].nodeType === Node.TEXT_NODE) {
            var newNode = document.createElement('div');
            RE.createWrapper(contents[i], newNode);
            RE.focus();
        }
    }
}//Returns the cursor position relative to its current position onscreen.// Can be negative if it is above what is
RE.getRelativeCaretYPosition = function () {
    var sel = window.getSelection();
    // Next line is comented to prevent deselecting selection. It looks like work but if there are any issues will appear then uconmment it as well as code above.
    //sel.collapseToStart();
    var range = sel.getRangeAt(0);
    var span = document.createElement('span');// something happening here preventing selection of elements
    range.collapse(false);
    span.appendChild(document.createTextNode("temp"))
    range.insertNode(span);
    var topPosition = span.offsetTop;
    span.parentNode.removeChild(span);    //
    TapTapAPI('HEIGHT', topPosition)
    return topPosition;
};
function getSelectionBoundaryElement(isStart) {
    var range, sel, container;
    if (document.selection) {
        range = document.selection.createRange();
        range.collapse(isStart);
        return range.parentElement();
    } else {
        sel = window.getSelection();
        if (sel.getRangeAt) {
            if (sel.rangeCount > 0) {
                range = sel.getRangeAt(0);
            }
        }
        else {            // Old WebKit
            range = document.createRange();
            range.setStart(sel.anchorNode, sel.anchorOffset);
            range.setEnd(sel.focusNode, sel.focusOffset);
            // Handle the case when the selection was selected backwards (from the end to the start in the document)
            if (range.collapsed !== sel.isCollapsed) {
                range.setStart(sel.focusNode, sel.focusOffset);
                range.setEnd(sel.anchorNode, sel.anchorOffset);
            }
        }
        if (range) {
            container = range[isStart ? "startContainer" : "endContainer"];
            // Check if the container is a text node and return its parent if so
            return container.nodeType === 3 ? container.parentNode : container;
        }
    }
}

window.onresize = function (e) {

    RE.calculateEditorHeightWithCaretPosition();
//    window.postMessage('onresize');
//    console.log("onresize");

}
window.onkeydown = function (e) {
    var code = e.keyCode;
    if (code === 8) { //up key       // alert(getSelectionBoundaryElement('start).nodeName)
    }
};


RE.setImageLoading = function (imgId) {
    var html = '<img  src="./icon_seat@3x.png" id="' + imgId + '"/>';
    RE.insertHTML(html);
    RE.callback();
};


RE.updateImageURL = function (imgId, imgUrl) {
    var imgElem = document.getElementById(imgId);
    imgElem.setAttribute('src', imgUrl);
    RE.callback();
};


RE.delImageLoading = function (imgId) {
    var imgElem = document.getElementById(imgId);
    if (!imgElem) {
        return;
    }
    imgElem.parentNode.removeChild(imgElem);
};


RE.insertImageBase64String = function (imageBase64String, alt) {
    var html = '<img data-gid="' + alt + '" class="gameItem" src="data:image/jpeg;base64,' + imageBase64String + '"/>';
    RE.insertHTML(html);
    RE.callback();
}

RE.setBold = function () {
    document.execCommand('bold', false, null);
}

RE.insertText = function (content) {
    RE.insertHTML(content);
    RE.callback();
}


/**
 *  从剪切板获取文本
 *  @params e 剪切板对象
 *  @return 是否已处理
 **/
RE.pasteNormalCallback = function (e) {
    if (event.clipboardData || event.originalEvent) {
        var clipboardData = (event.clipboardData || event.originalEvent.clipboardData);
        if (typeof(clipboardData) != "undefined" && clipboardData != null) {
            var data;
            if (clipboardData.types.indexOf('text/html') > -1) {//html
                data = clipboardData.getData('text/plain');
            } else if (clipboardData.types.indexOf('text/plain') > -1) {//无文本格式
                data = clipboardData.getData('text/plain');
            }
            if (null != data) {
                window.postMessage('pastContent:::' + data);
                e.preventDefault(); // We are already handling the data from the clipboard, we do not want it inserted into the document
                return true;
            }
            return false;
        }
    }
}

/**
 *  使用透明布局插入方式
 *  代码参照 https://github.com/wbb/wysibb/blob/master/jquery.wysibb.js#L837
 *  @params e 剪切板对象
 *  @return 是否已处理
 **/
RE.pasteSpecialCallback = function (e) {
    var originScrollTop = $('body').scrollTop();
    if (!RE.editor.pasteBlock) {
        RE.saveRange();
        // append translate div
        RE.pasteBlock = document.createElement("div");
        RE.pasteBlock.setAttribute("style", "opacity:0;");
        RE.pasteBlock.setAttribute("contenteditable", "true");
        RE.pasteBlock.innerHTML = "\uFEFF";
        RE.editor.appendChild(RE.pasteBlock);

        window.setTimeout(function () {
            var data = '<span>' + RE.pasteBlock.innerHTML + '</span>';
            RE.editor.removeChild(RE.pasteBlock);
            RE.editor.focus();

            RE.selectRange(RE.lastRange);

            window.postMessage('pastContent:::' + data);

            RE.pasteBlock = null;
            RE.lastRange = null;

            $('body').scrollTop(originScrollTop);
        }, 1);
        RE.selectNode(RE.pasteBlock);
        return true;
    }
    return false;
}


RE.editor.addEventListener("paste", function (e) {
    if (RE.pasteNormalCallback(e)) {
        return;
    }
    if (RE.pasteSpecialCallback(e)) {
        return;
    }
});

